<?php
/** 
*
* @package phpAR
* @version $Id: arcade.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/file_functions.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
// End session management

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'arcade_body.html'
));

$action	= request_var('action', '');
$game_id = request_var('g', 0);

// Check if games can be favorited
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 5 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
$db->sql_freeresult($result);

$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $user->lang['ARCADE'],
	'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}arcade.$phpEx", '', true, $user->session_id))
);

// Grab game details for category display
$sql = 'SELECT category_id, category_name
	FROM ' . AR_CATEGORIES_TABLE . '
	ORDER BY category_name';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	// Grab game details for a total count for the category
	$sql = 'SELECT COUNT(game_category) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 1 AND game_category = ' . $row['category_id'];
	$result2 = $db->sql_query($sql);
	$row_count = (int) $db->sql_fetchfield('row_count');
	$db->sql_freeresult($result2);

	// Send vars to template
	$template->assign_block_vars('categoryrow', array(
			'CATEGORY_ID'			=> $row['category_id'],
			'CATEGORY_NAME'			=> $row['category_name'],
			'CATEGORY_COUNT'		=> '(' . $row_count . ')'
	));
}
$db->sql_freeresult($result);

// Check if guests can view the arcade
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 1 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$template->assign_vars(array(
			'S_VIEW'		=> true
	));
}
$db->sql_freeresult($result);
if ($user->data['is_registered'])
{
	$template->assign_vars(array(
			'S_VIEW'		=> true,
			'S_YOUR_INFO'	=> true
	));
}

// Grab game details for a total count
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
$total_games = $row_count;
if ($row_count > 0)
{
	$template->assign_vars(array(
		'L_NUM_GAMES'	=> '(' . $row_count . ')',
		'S_ARCADE'		=> true,
		'S_ALL_GAMES'	=> true
	));
}
else
{
	$template->assign_vars(array(
		'S_ARCADE'		=> true,
		'S_ALL_GAMES'	=> false
	));
}
$db->sql_freeresult($result);
// Grab game details for a favorites count
$sql = 'SELECT COUNT(favorite_id) AS row_count FROM ' . AR_FAVORITES_TABLE . ' WHERE favorite_user = ' . $user->data['user_id'];
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count > 0)
{
	$fav_url = append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=arcade&mode=favorites', true, $user->session_id);
	$template->assign_vars(array(
		'L_FAV_GAMES'	=> '(' . $row_count . ')',
		'S_FAVORITES'	=> true
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on date added
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_enabled = 1
	ORDER BY game_id DESC
	LIMIT 3';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('latestrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on plays
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_enabled = 1
	ORDER BY game_plays DESC
	LIMIT 3';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('playedrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on rating
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_enabled = 1
	ORDER BY game_rating DESC, game_num_ratings DESC
	LIMIT 3';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('ratingrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

$user_golds = 0;
$user_silvers = 0;
$user_bronzes = 0;
$bronze = "<img src='{$phpbb_root_path}/arcade/images/trophy_bronze.gif' align='absmiddle' alt='bronze' />";
$silver = "<img src='{$phpbb_root_path}/arcade/images/trophy_silver.gif' align='absmiddle' alt='silver' />";
$gold = "<img src='{$phpbb_root_path}/arcade/images/trophy_gold.gif' align='absmiddle' alt='gold' />";
$sql = 'SELECT highscore_game, highscore
	FROM ' . AR_HIGHSCORES_TABLE . '
	WHERE highscore_user = ' . $user->data['user_id'] . '
	ORDER BY highscore_game DESC';
$result = $db->sql_query($sql);
while ($row = $db->sql_fetchrow($result))
{
	// Grab game details for a total count for the category
	$sql = 'SELECT game_id, game_name
		FROM ' . AR_GAMES_TABLE . '
		WHERE game_id = ' . (int) $row['highscore_game'] . '
			AND game_enabled = 1';
	$result2 = $db->sql_query($sql);
	$row2 = $db->sql_fetchrow($result2);
	$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $row['highscore_game'], false, $user->session_id);
	$game_name = '<a href="' . $url_loc . '">' . $row2['game_name'] . '</a>';
	if ($row2['game_name'])
	{
		$game_ids[$game_name] = $row['highscore_game'];
		$highscores[$game_name][sizeof($highscores[$game_name])] = $row['highscore'];
	}
	$db->sql_freeresult($result2);
}
if (@$highscores)
{
	foreach($highscores as $key => $value)
	{
		unset($extra);
		$score_count = sizeof($highscores[$key]);
		if ($score_count > 1)
		{
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_ids[$key] . '&amp;u=' . $user->data['user_id'] . '&amp;action=viewhighscore', true, $user->session_id);
			$extra = "(<a href='$url_loc'>$score_count</a>)";
		}
		
		// Check if game can be has reverse scoring
		$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $game_ids[$key] . ' AND game_rev_score = 1';
		$result6 = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		if ($row_count)
		{
			$rev_scoring = 'ASC';
		}
		else
		{
			$rev_scoring = 'DESC';
		}
		
		$sql = 'SELECT highscore_user
			FROM ' . AR_HIGHSCORES_TABLE . '
			WHERE highscore_game = ' . $game_ids[$key] . '
			ORDER BY highscore ' . $rev_scoring;
		$result4 = $db->sql_query($sql);
		$scores_count = 0;
		$game_scores = array();
		while($row4 = $db->sql_fetchrow($result4))
		{
			$game_scores[$scores_count] = $row4['highscore_user'];
			$scores_count++;
		}
		$db->sql_freeresult($result3);
		if (sizeof(array_unique($game_scores)) > 2)
		{
			$scores_count = 2;
			while($game_scores[0] == $game_scores[1])
			{
				$game_scores[1] = $game_scores[$scores_count];
				$scores_count++;
			}
			$scores_count = 3;
			while($game_scores[0] == $game_scores[2] || $game_scores[1] == $game_scores[2])
			{
				$game_scores[2] = $game_scores[$scores_count];
				$scores_count++;
			}
			if ($game_scores[0] == $user->data['user_id'])
			{
				$extra .= $gold;
				$user_golds++;
			}
			if ($game_scores[1] == $user->data['user_id'])
			{
				$extra .= $silver;
				$user_silvers++;
			}
			if ($game_scores[2] == $user->data['user_id'])
			{
				$extra .= $bronze;
				$user_bronzes++;
			}
		}
	}
}
$db->sql_freeresult($result);
$template->assign_vars(array(
	'GOLD'			=> $gold,
	'SILVER'		=> $silver,
	'BRONZE'		=> $bronze,
	'USER_GOLD'		=> $user_golds,
	'USER_SILVER'	=> $user_silvers,
	'USER_BRONZE'	=> $user_bronzes
));

// Check how many games the user has played
$sql = 'SELECT played_games
	FROM ' . AR_PLAYED_TABLE . '
	WHERE played_user = ' . (int) $user->data['user_id'];
$result = $db->sql_query($sql);
$played_games = array();
while ($row = $db->sql_fetchrow($result))
{
	$played_games = explode('-', $row['played_games']);
}
$db->sql_freeresult($result);
$games_played = sizeof($played_games);
$sql = 'SELECT COUNT(rating_id) AS row_count FROM ' . AR_RATINGS_TABLE . ' WHERE rating_user = ' . (int) $user->data['user_id'];
$result = $db->sql_query($sql);
$rated_games = (int) $db->sql_fetchfield('row_count');
$template->assign_vars(array(
	'PLAYED_GAMES'		=> $games_played,
	'TOTAL_GAMES'		=> $total_games,
	'RATED_GAMES'		=> $rated_games
));

// Grab game details for favorites display
$sql = 'SELECT favorite_game
	FROM ' . AR_FAVORITES_TABLE . '
	WHERE favorite_user = ' . $user->data['user_id'];
$result = $db->sql_query($sql);
$count = 1;
while ($row = $db->sql_fetchrow($result))
{
	if ($count < 2)
	{
		$sql_addition = 'WHERE game_id = ' . $row['favorite_game'];
	}
	else
	{
		$sql_addition .= ' OR game_id = ' . $row['favorite_game'];
	}
	$count++;
}
$db->sql_freeresult($result);
// Grab game details for favorites section
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	' . $sql_addition . '
	ORDER BY RAND()
	LIMIT 20';
$result = $db->sql_query($sql);
$row_count = 0;
while ($row = $db->sql_fetchrow($result))
{
	// Check if game can be has reverse scoring
	$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $row['game_id'] . ' AND game_enabled = 1';
	$result2 = $db->sql_query($sql);
	$enabled = (int) $db->sql_fetchfield('row_count');
	if ($enabled && $row_count < 8)
	{
		if ($row['game_rating'] >  0)
		{
			$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
		}
		else
		{
			$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
		}
		$row_count++;
		// Send vars to template
		$template->assign_block_vars('favoriterow', array(
				'ROW_COUNT'			=> $row_count,
				'GAME_ID'			=> $row['game_id'],
				'GAME_NAME'			=> $row['game_name'],
				'GAME_IMAGE'		=> $row['game_image'],
				'GAME_PLAYS'		=> $row['game_plays'],
				'GAME_RATING'		=> $rstars,
				'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
				'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
		));
	}
}
$db->sql_freeresult($result);

if (($row_count & 1) != 0)
{
	$template->assign_vars(array(
		'S_LAST_PART'	=> true
	));
	$rand_count = round($row_count / 2);
}
else
{
	$rand_count = floor($row_count / 2);
}
// Grab game details for random game display
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_enabled = 1
	ORDER BY RAND()
	LIMIT ' . $rand_count;
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('randomrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

page_footer();

?>