<?php
/** 
*
* @package phpAR
* @version $Id: update.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/file_functions.' . $phpEx);

define('AR_PLAYED_TABLE',			$table_prefix . 'ar_played');

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
// End session management

if (!$user->data['is_registered'])
{
    if ($user->data['is_bot'])
    {
        redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
    }
    login_box('', 'LOGIN');
}
else if ($user->data['user_type'] != USER_FOUNDER)
{
    die('You are not the board founder.');
}

$titlefont = '<font color="#0077AA">';
$goodfont = '<font color="#007700">';
$okfont = '<font color="#AA7700">';
$badfont = '<font color="#770000">';
$cfont = '</font>';

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'arcade_install.html')
);

$db->sql_return_on_error(true);

$action	= request_var('action', '');

$message = '';

switch ($action)
{
	default:
		$message .= $titlefont . $user->lang['AR_WELCOME'] . '<br /><br />' . $user->lang['AR_EXPLAIN'] . '<br /><br />' . $user->lang['AR_TO_BEGIN'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update.' . $phpEx,
			'L_VALUE'	=> 'mysql',
			'L_BUTTON'	=> $user->lang['BEGIN']
		));
	break;
	case 'mysql':
		switch ($db->sql_layer)
		{
			case 'mysql':
				$db_type = 'mysql_40';
			break;
		
			case 'mysql4':
				if (version_compare($db->mysql_version, '4.1.3', '>='))
				{
					$db_type = 'mysql_41';
				}
				else
				{
					$db_type = 'mysql_40';
				}
			break;
		
			case 'mysqli':
				$db_type = 'mysql_41';
			break;
		
			default:
				$db_type = $db->sql_layer;
			break;
		}
		$message .= $titlefont . $user->lang['MYSQL_EDITS'] . $cfont;
		
		$sql = 'ALTER TABLE ' . AR_GAMES_TABLE . " ADD game_rev_score TINYINT(1) UNSIGNED NOT NULL DEFAULT '0', ADD game_enabled TINYINT(1) UNSIGNED NOT NULL DEFAULT '1'";
		if ($db->sql_query($sql))
		{
			$message .= $goodfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $badfont . '<br />' . AR_GAMES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
		}
		
		$sql = 'ALTER TABLE ' . AR_HIGHSCORES_TABLE . " CHANGE `highscore` `highscore` DOUBLE( 21, 1 ) UNSIGNED NOT NULL";
		if ($db->sql_query($sql))
		{
			$message .= $goodfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
		}
		else
		{
			$message .= $badfont . '<br />' . AR_HIGHSCORES_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
		}
		
		if(!$db->sql_query("SELECT * FROM " . AR_PLAYED_TABLE))
		{
			$sql = 'CREATE TABLE ' . AR_PLAYED_TABLE . " (
			  played_id mediumint(8) unsigned NOT NULL auto_increment,
			  played_user mediumint(8) unsigned NOT NULL,
			  played_games mediumtext character set utf8 collate utf8_bin NOT NULL,
			  PRIMARY KEY  (played_id)
			)";
			if ($db_type == 'mysql_41')
			{
				$sql .= 'CHARACTER SET `utf8` COLLATE `utf8_bin`';
			}
			if ($db->sql_query($sql))
			{
				$message .= $goodfont . '<br />' . AR_PLAYED_TABLE . $user->lang['DATABASE_SUCCESS'] . $cfont;
			}
			else
			{
				$message .= $badfont . '<br />' . AR_PLAYED_TABLE . $user->lang['DATABASE_ERROR'] . $cfont;
			}
		}
		else
		{
			$message .= $okfont . '<br />' . AR_PLAYED_TABLE . $user->lang['DATABASE_EXISTS'] . $cfont;
		}
		$message .= $titlefont . '<br /><br />' . $user->lang['MYSQL_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update.' . $phpEx,
			'L_VALUE'	=> 'edits',
			'L_BUTTON'	=> $user->lang['EDIT_FILES']
		));
	break;
	case 'edits':
		$message .= $titlefont . $user->lang['FILE_EDITS'] . $cfont;

		$message .= 'The files edits have been broken for this release.  Go <a href="http://gleasonator.com/patrikstar/phpBB3/viewtopic.php?f=2&t=5">here</a> and do those edits to finish your update process.';
		
		$message .= $titlefont . '<br /><br />' . $user->lang['EDITS_DONE'] . $cfont;
		$template->assign_vars(array(
			'U_ACTION'	=> 'update.' . $phpEx,
			'L_VALUE'	=> 'finish',
			'L_BUTTON'	=> $user->lang['FINISH']
		));
	break;
	case 'finish':
		$message .= $titlefont . $user->lang['IF_OK'] . $cfont;
		$message .= $titlefont . '<br /><br />' . $user->lang['FINAL_STEPS'] . $cfont;
		global $cache;
		$cache->purge();
		add_log('admin', 'LOG_PURGE_CACHE');
		$template->assign_vars(array(
			'U_ACTION'	=> 'update.' . $phpEx,
			'L_VALUE'	=> 'delete',
			'L_BUTTON'	=> $user->lang['DELETE']
		));
	break;
	case 'delete':
		unlink('update.php');
		header("Location: index.php");
	break;
}

$template->assign_vars(array(
		'L_MESSAGE'		=>	$message,
		'S_INSTALL'		=>	true,
		'S_ARCADE'		=>	true
));

page_footer();

?>