<?php
/** 
*
* @package phpAR
* @version $Id: viewcategory.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/file_functions.' . $phpEx);

$action	= request_var('action', '');
$game_id = request_var('g', 0);
$category_id = request_var('c', 0);
$offset = request_var('start', 0);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
$user->setup('posting');
// End session management

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'viewcategory_body.html'
));

// Check if games can be favorited
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 5 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$allow_favorites = true;
}
else
{
	$allow_favorites = false;
}
$db->sql_freeresult($result);

$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $user->lang['ARCADE'],
	'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}arcade.$phpEx", '', true, $user->session_id))
);

// Check if category_id is a valid category
$sql = 'SELECT COUNT(category_id) AS row_count FROM ' . AR_CATEGORIES_TABLE . " WHERE category_id = $category_id";
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if (!$row_count && $category_id != 0 && $category_id != 105121)
{
	header("Location: arcade.php");
}
$db->sql_freeresult($result);

if ($category_id == 105121)
{
	// Grab game details for category display
	$sql = 'SELECT favorite_game
		FROM ' . AR_FAVORITES_TABLE . '
		WHERE favorite_user = ' . $user->data['user_id'];
	$result = $db->sql_query($sql);
	$count = 1;
	while ($row = $db->sql_fetchrow($result))
	{
		if ($count < 2)
		{
			$sql_addition = 'WHERE game_id = ' . $row['favorite_game'] . ' AND game_enabled = 1';
		}
		else
		{
			$sql_addition .= ' OR game_id = ' . $row['favorite_game'] . ' AND game_enabled = 1';
		}
		$count++;
	}
	$db->sql_freeresult($result);
}
else if ($category_id)
{
	$sql_addition = 'WHERE game_enabled = 1 AND game_category = ' . $category_id;
	$sql_addition_extra = ' WHERE game_category = ' . $category_id;
}
else
{
	$sql_addition = 'WHERE game_enabled = 1';
}

if ($category_id == 0)
{
	if ($user->data['user_type'] == USER_FOUNDER)
	{
		// Generate Pagination
		$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE;
		$result = $db->sql_query($sql);
		$total_games = (int) $db->sql_fetchfield('row_count');
	}
	else
	{
		// Generate Pagination
		$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 1';
		$result = $db->sql_query($sql);
		$total_games = (int) $db->sql_fetchfield('row_count');
	}
}
else if ($category_id == 105121)
{
	// Generate Pagination
	$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' ' . $sql_addition;
	$result = $db->sql_query($sql);
	$total_games = (int) $db->sql_fetchfield('row_count');
	$template->assign_vars(array(
		'L_FAV_GAMES'	=> '(' . $total_games . ')',
		'S_FAVORITES'	=> true
	));
}
else
{
	// Generate Pagination
	$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 1 AND game_category = ' . $category_id;
	$result = $db->sql_query($sql);
	$total_games = (int) $db->sql_fetchfield('row_count');
}
$pagination = generate_pagination(append_sid("{$phpbb_root_path}viewcategory.$phpEx", "c=$category_id", true, $user->session_id), $total_games, 10, $offset);

$template->assign_vars(array(
	'CAT_NUM_GAMES'	=> $total_games,
	'PAGINATION' 	=> $pagination,
	'PAGE_NUMBER' 	=> on_page($total_games, 10, $offset),
));

// Grab game details for category display
$sql = 'SELECT favorite_game
	FROM ' . AR_FAVORITES_TABLE . '
	WHERE favorite_user = ' . $user->data['user_id'];
$result = $db->sql_query($sql);
$count = 1;
while ($row = $db->sql_fetchrow($result))
{
	if ($count < 2)
	{
		$sql_addition2 = 'WHERE game_id = ' . $row['favorite_game'] . ' AND game_enabled = 1';
	}
	else
	{
		$sql_addition2 .= ' OR game_id = ' . $row['favorite_game'] . ' AND game_enabled = 1';
	}
	$count++;
}
$db->sql_freeresult($result);

// Check Favorite games count
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' ' . $sql_addition2;
$result = $db->sql_query($sql);
$total_games = (int) $db->sql_fetchfield('row_count');
$template->assign_vars(array(
	'L_FAV_GAMES'	=> '(' . $total_games . ')',
	'S_FAVORITES'	=> true
));

// Check if guests can view the arcade
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 1 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$template->assign_vars(array(
			'S_VIEW'		=> true
	));
}
$db->sql_freeresult($result);

if ($user->data['user_type'] == USER_FOUNDER)
{
	// Grab game details for a total count
	$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE;
	$result = $db->sql_query($sql);
	$row_count = (int) $db->sql_fetchfield('row_count');
	if ($row_count > 0)
	{
		$template->assign_vars(array(
			'L_NUM_GAMES'	=> '(' . $row_count . ')',
			'S_ARCADE'		=> true,
			'S_ALL_GAMES'	=> true
		));
	}
	else
	{
		$template->assign_vars(array(
			'S_ARCADE'		=> true,
			'S_ALL_GAMES'	=> false
		));
	}
	$db->sql_freeresult($result);
}
else
{
	// Grab game details for a total count
	$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 1';
	$result = $db->sql_query($sql);
	$row_count = (int) $db->sql_fetchfield('row_count');
	if ($row_count > 0)
	{
		$template->assign_vars(array(
			'L_NUM_GAMES'	=> '(' . $row_count . ')',
			'S_ARCADE'		=> true,
			'S_ALL_GAMES'	=> true
		));
	}
	else
	{
		$template->assign_vars(array(
			'S_ARCADE'		=> true,
			'S_ALL_GAMES'	=> false
		));
	}
	$db->sql_freeresult($result);
}

if ($category_id == 0)
{
	$row['category_name'] = 'All Games';
	$template->assign_vars(array(
		'S_IN_ALL_GAMES'			=> true
	));
}
else if ($category_id == 105121)
{
	$row['category_name'] = 'Favorites';
	$template->assign_vars(array(
		'S_IN_FAVORITES'			=> true
	));
}
else
{
	// Grab group details for category display
	$sql = 'SELECT category_name
		FROM ' . AR_CATEGORIES_TABLE . '
		WHERE category_id = ' . $category_id . '
		ORDER BY category_name';
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
}
$template->assign_vars(array(
	'CATEGORY_NAME'		=> $row['category_name'],
	'S_ARCADE'			=> true
));

$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $row['category_name'],
	'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}viewcategory.$phpEx", 'c=' . $category_id, true, $user->session_id))
);
$db->sql_freeresult($result);

// Grab game details for category display
$sql = 'SELECT category_id, category_name
	FROM ' . AR_CATEGORIES_TABLE . '
	ORDER BY category_name';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	// Grab game details for a total count for the category
	$sql = 'SELECT COUNT(game_category) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 1 AND game_category = ' . $row['category_id'];
	$result2 = $db->sql_query($sql);
	$row_count = (int) $db->sql_fetchfield('row_count');
	$db->sql_freeresult($result2);
	
	if ($row['category_id'] == $category_id) {
		// Send vars to template
		$template->assign_block_vars('categoryrow', array(
				'CATEGORY_ID'			=> $row['category_id'],
				'CATEGORY_NAME'			=> '<strong>' . $row['category_name'] . '</strong>',
				'CATEGORY_COUNT'		=> '(' . $row_count . ')'
		));
	}
	else
	{
		// Send vars to template
		$template->assign_block_vars('categoryrow', array(
				'CATEGORY_ID'			=> $row['category_id'],
				'CATEGORY_NAME'			=> $row['category_name'],
				'CATEGORY_COUNT'		=> '(' . $row_count . ')'
		));
	}
}
$db->sql_freeresult($result);

// Check if guests can view the arcade
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 1 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$template->assign_vars(array(
			'S_VIEW'		=> true
	));
}
if ($user->data['user_id'] != ANONYMOUS)
{
	$template->assign_vars(array(
			'S_VIEW'		=> true
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on date added
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	' . $sql_addition . '
	ORDER BY game_id DESC
	LIMIT 3';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('latestrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on plays
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	' . $sql_addition . '
	ORDER BY game_plays DESC
	LIMIT 3';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('playedrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

// Grab game details for game display based on rating
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	' . $sql_addition . '
	ORDER BY game_rating DESC, game_num_ratings DESC
	LIMIT 3';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	// Send vars to template
	$template->assign_block_vars('ratingrow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename'])
	));
}
$db->sql_freeresult($result);

// Grab game details for game display of games in the category
if ($user->data['user_type'] == USER_FOUNDER && $category_id == 0)
{
	$sql = 'SELECT *
		FROM ' . AR_GAMES_TABLE . $sql_addition_extra . '
		ORDER BY game_name
		LIMIT ' . $offset . ',10';
	$result = $db->sql_query($sql);
}
else
{
	$sql = 'SELECT *
		FROM ' . AR_GAMES_TABLE . '
		' . $sql_addition . '
		ORDER BY game_name
		LIMIT ' . $offset . ',10';
	$result = $db->sql_query($sql);
}
while ($row = $db->sql_fetchrow($result))
{
	if ($row['game_rating'] >  0)
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star_" . $row['game_rating'] . ".gif' alt='" . $row['game_rating'] . "' />";
	}
	else
	{
		$rstars = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='0' />";
	}
	
	// Check if game can be has reverse scoring
	$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $row['game_id'] . ' AND game_rev_score = 1';
	$result3 = $db->sql_query($sql);
	$row_count = (int) $db->sql_fetchfield('row_count');
	if ($row_count)
	{
		$rev_scoring = 'ASC';
	}
	else
	{
		$rev_scoring = 'DESC';
	}
	$username = '';
	// Get highest score for game
	$sql = 'SELECT highscore_user, highscore
		FROM ' . AR_HIGHSCORES_TABLE . '
		WHERE highscore_game = ' . $row['game_id'] . '
		ORDER BY highscore ' . $rev_scoring;
	$result2 = $db->sql_query($sql);
	$row2 = $db->sql_fetchrow($result2);
	$highest_score = str_replace('.0', '', $row2['highscore']);
	$highest_score_user = $row2['highscore_user'];
	$db->sql_freeresult($result2);
	if ($highest_score)
	{
		// Grab game details for a total count for the category
		$sql = 'SELECT username, user_colour
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . (int) $highest_score_user;
		$result2 = $db->sql_query($sql);
		$row2 = $db->sql_fetchrow($result2);
		$username = ' - ' . get_username_string('full', $highest_score_user, $row2['username'], $row2['user_colour'], $row2['username']);
		$db->sql_freeresult($result3);
	}
	if ($highest_score == 0)
	{
		$highest_score = '-';
	}
	if ($row['game_enabled'] == 0)
	{
		$disabled = true;
	}
	else
	{
		$disabled = false;
	}
	
	// Send vars to template
	$template->assign_block_vars('gamerow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_DESC'			=> $row['game_description'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_PLAYS'		=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUM_RATINGS'	=> $row['game_num_ratings'],
			'GAME_SIZE'			=> get_file_size("arcade/" . $row['game_filename']),
			'GAME_HIGH_SCORE'	=> $highest_score . $username,
			'S_DISABLED'		=> $disabled
	));
}
$db->sql_freeresult($result);

page_footer();

?>