<?php
/** 
*
* @package phpAR
* @version $Id: viewgame.php
* @copyright (c) 2007 gfxPros
* @website http://www.gfx-pros.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/file_functions.' . $phpEx);

$game_id = request_var('g', 0);
$offset = request_var('start', 0);
if ($game_id == '')
{
	$url_loc = append_sid("{$phpbb_root_path}arcade.$phpEx", '', true, $user->session_id);
	header("Location: $url_loc");
}

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/arcade');
$user->setup('posting');
// End session management

$sql = 'SELECT COUNT(game_name) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_enabled = 0 AND game_id = ' . $game_id;
$result = $db->sql_query($sql);
$total_games = (int) $db->sql_fetchfield('row_count');
if ($total_games == 1 && $user->data['user_type'] != USER_FOUNDER)
{
	$url_loc = append_sid("{$phpbb_root_path}arcade.$phpEx", '', true, $user->session_id);
	header("Location: $url_loc");
}

// Output page
page_header($user->lang['ARCADE']);

$template->set_filenames(array(
	'body' => 'viewgame_body.html'
));

// Check if games can be commented on
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 3 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$allow_comments = true;
}
else
{
	$allow_comments = false;
}
$db->sql_freeresult($result);

// Generate Pagination
$sql = 'SELECT COUNT(comment_id) AS row_count FROM ' . AR_COMMENTS_TABLE . ' WHERE comment_game = ' . $game_id;
$result = $db->sql_query($sql);
$total_games = (int) $db->sql_fetchfield('row_count');

$pagination = generate_pagination(append_sid("{$phpbb_root_path}viewgame.$phpEx", "g=$game_id&amp;action=p", true, $user->session_id), $total_games, 5, $offset);

$template->assign_vars(array(
		'PAGINATION' 	=> $pagination,
		'PAGE_NUMBER' 	=> on_page($total_games, 5, $offset),
));

// Check hotlink protection is enabled
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 4 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$hotlink_protection = true;
}
else
{
	$hotlink_protection = false;
}
$db->sql_freeresult($result);

// Check if games can be favorited
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 5 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$allow_favorites = true;
}
else
{
	$allow_favorites = false;
}
$db->sql_freeresult($result);

// Check if game is a highscore game
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $game_id . ' AND game_highscore = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$game_highscore = true;
}
else
{
	$game_highscore = false;
}
$db->sql_freeresult($result);

// Check if game uses the newscore.php version of highscores
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $game_id . ' AND game_newscore = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$game_newscore = true;
}
else
{
	$game_newscore = false;
}
$db->sql_freeresult($result);

if ($auth->acl_getf_global('m_'))
{
	$template->assign_vars(array(
			'S_COMMENTS'		=> true
	));
}
$action	= request_var('action', '');
switch ($action)
{
	case 'remove':
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . "
				AND favorite_game = $game_id";
		$result = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		if ($favorite_id)
		{
			$sql = 'DELETE FROM ' . AR_FAVORITES_TABLE . ' WHERE favorite_id = ' . (int) $favorite_id;
			$db->sql_query($sql);
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		} else {
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		$db->sql_freeresult($result);
	break;
	case 'newhighscore':
		if ($game_highscore == true && $user->data['is_registered'])
		{
			// Deny $HTTP_GET_VARS Mode Games
			if(@$HTTP_GET_VARS['score'])
			{
				$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");	
			}
			
			$score = (($HTTP_POST_VARS['score'])) ? $HTTP_POST_VARS['score'] : $_POST['score'];
			
			$sql = 'SELECT highscore_id FROM ' . AR_HIGHSCORES_TABLE . '
				WHERE highscore_user = ' . $user->data['user_id'] . "
					AND highscore_game = $game_id
					AND highscore = $score";
			$result = $db->sql_query($sql);
			$highscore_id = (int) $db->sql_fetchfield('highscore_id');
			if (!$highscore_id)
			{			
				$sql_ary = array(
					'highscore_game'	=> $game_id,
					'highscore_user'	=> $user->data['user_id'],
					'highscore'			=> $score
				);
				$sql = 'INSERT INTO ' . AR_HIGHSCORES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
			}
			$db->sql_freeresult($result);
		}
		$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
	break;
	case 'add':
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . "
				AND favorite_game = $game_id";
		$result = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		if (!$favorite_id)
		{
			$sql_ary = array(
				'favorite_game'		=> $game_id,
				'favorite_user'		=> $user->data['user_id']
			);
			$sql = 'INSERT INTO ' . AR_FAVORITES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		} else {
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		$db->sql_freeresult($result);
	break;
	case 'delete':
		$cid = request_var('c', 0);
		$sql = 'SELECT *
			FROM ' . AR_COMMENTS_TABLE . '
			WHERE comment_id = ' . $cid;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		if ($auth->acl_getf_global('m_') || $user->data['user_id'] == $row['comment_user'])
		{
			$sql = 'DELETE FROM ' . AR_COMMENTS_TABLE . ' WHERE comment_id = ' . (int) $cid;
			$db->sql_query($sql);
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		} else {
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		$db->sql_freeresult($result);
	break;
	case 'edit':
		$cid = request_var('c', 0);
		$sql = 'SELECT comment, bbcode_uid
			FROM ' . AR_COMMENTS_TABLE . '
			WHERE comment_id = ' . $cid;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		
		decode_message($row['comment'], $row['bbcode_uid']);
		if (!$allow_comments)
		{
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		if ($auth->acl_getf_global('m_') || $user->data['user_id'] == $row['comment_user'])
		{
			$url = $phpbb_root_path . 'viewgame.' . $phpEx . "?action=update&amp;c=$cid&amp;g=$game_id";
			$template->assign_vars(array(
					'S_EDIT'	=> true,
					'U_ACTION'	=> $url,
					'COMMENT'	=> $row['comment'],
					'S_BBCODE_ALLOWED'	=> true
			));
		} else {
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		$db->sql_freeresult($result);
	break;
	case 'viewhighscore':
		$sql = 'SELECT game_name
			FROM ' . AR_GAMES_TABLE . '
			WHERE game_id = ' . (int) $game_id;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$game_name = $row['game_name'];
		$db->sql_freeresult($result);
		
		$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id, true, $user->session_id);
		
		$game_loc = '<a href="' . $url_loc . '">' . $game_name . '</a>';

		$user_id = request_var('u', 0);
		
		// Check if game can be has reverse scoring
		$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $game_id . ' AND game_rev_score = 1';
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		if ($row_count)
		{
			$rev_scoring = 'ASC';
		}
		else
		{
			$rev_scoring = 'DESC';
		}
		
		$sql = 'SELECT highscore
			FROM ' . AR_HIGHSCORES_TABLE . '
			WHERE highscore_game = ' . $game_id . '
				AND highscore_user = ' . $user_id . '
			ORDER BY highscore ' . $rev_scoring;
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			// Grab game details for a total count for the category
			$sql = 'SELECT username, user_colour
				FROM ' . USERS_TABLE . '
				WHERE user_id = ' . (int) $user_id;
			$result2 = $db->sql_query($sql);
			$row2 = $db->sql_fetchrow($result2);
			$username = get_username_string('full', $user_id, $row2['username'], $row2['user_colour'], $row2['username']);
			$db->sql_freeresult($result2);

			@$highscores[$username][sizeof($highscores[$username])] = str_replace('.0', '', $row['highscore']);
		}
		if (@$highscores)
		{
			foreach($highscores as $key => $value)
			{
				$score_count = sizeof($highscores[$key]);
				if ($score_count < 2)
				{
					$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
					header("Location: $url_loc");
				}
				$template->assign_vars(array(
					'U_SCORE_USER'	=> $user->lang['HIGHSCORES_FOR'] . $key . ' ' . $user->lang['IN'] . ' ' . $game_loc
				));
				foreach($highscores[$key] as $key2 => $value2)
				{
					// Send vars to template
					$template->assign_block_vars('userscorerow', array(
							'SCORE'			=> $value2
					));
				}
			}
		}
		else
		{
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		$db->sql_freeresult($result);
		$template->assign_vars(array(
				'S_VIEW_HIGHSCORES'	=> true
		));
	break;
	case 'update':
		$cid = request_var('c', 0);
		$sql = 'SELECT *
			FROM ' . AR_COMMENTS_TABLE . '
			WHERE comment_id = ' . $cid;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		if ($auth->acl_getf_global('m_') || $user->data['user_id'] == $row['comment_user'])
		{
			$comment = utf8_normalize_nfc(request_var('message', '', true));
			$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
			$allow_bbcode = $allow_urls = $allow_smilies = true;
			generate_text_for_storage($comment, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
			
			$sql_ary = array(
				'comment'			=> $comment,
				'bbcode_uid'        => $uid,
				'bbcode_bitfield'   => $bitfield,
				'enable_bbcode'     => $allow_bbcode,
				'enable_urls'       => $allow_urls,
				'enable_smilies'    => $allow_smilies
			);
			
			$sql = 'UPDATE ' . AR_COMMENTS_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
				WHERE comment_id = ' . (int) $cid;
			$db->sql_query($sql);
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		} else {
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
		}
		$db->sql_freeresult($result);
	break;
	case 'comment':
		$comment = utf8_normalize_nfc(request_var('message', '', true));
		if ($comment != '' && $allow_comments)
		{
			$comment = utf8_normalize_nfc(request_var('message', '', true));
			$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
			$allow_bbcode = $allow_urls = $allow_smilies = true;
			generate_text_for_storage($comment, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
			
			$sql_ary = array(
				'comment_game'		=> $game_id,
				'comment_user'		=> $user->data['user_id'],
				'comment'			=> $comment,
				'bbcode_uid'        => $uid,
				'bbcode_bitfield'   => $bitfield,
				'enable_bbcode'     => $allow_bbcode,
				'enable_urls'       => $allow_urls,
				'enable_smilies'    => $allow_smilies,
			);
			
			$sql = 'INSERT INTO ' . AR_COMMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
		$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");
	break;
	case 'rategame':
		$rating	= request_var('rating', 0);
		// Grab group details for rating display
		$sql = 'SELECT rating_id FROM ' . AR_RATINGS_TABLE . '
			WHERE rating_user = ' . $user->data['user_id'] . "
				AND rating_game = $game_id";
		$result = $db->sql_query($sql);
		$rating_id = (int) $db->sql_fetchfield('rating_id');
		if ($rating_id)
		{
			// Update number of game plays this game has been played
			$sql = 'UPDATE ' . AR_RATINGS_TABLE . ' SET rating_score = ' . $rating . ' WHERE rating_id = '. $rating_id;
			$db->sql_query($sql);
		}
		else
		{
			// Update number of game plays this game has been played
			$sql_ary = array(
				'rating_game'		=> $game_id,
				'rating_user'		=> $user->data['user_id'],
				'rating_score'		=> $rating
			);
			$sql = 'INSERT INTO ' . AR_RATINGS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
		$db->sql_freeresult($result);
		// Grab group details for rating display
		$sql = 'SELECT COUNT(rating_game) AS row_count FROM ' . AR_RATINGS_TABLE . " WHERE rating_game = $game_id";
		$result = $db->sql_query($sql);
		$row_count = (int) $db->sql_fetchfield('row_count');
		$db->sql_freeresult($result);

		$sql = 'SELECT rating_game, rating_score
			FROM ' . AR_RATINGS_TABLE . '
			WHERE rating_game = ' . $game_id;
		$result = $db->sql_query($sql);
		$rtotal = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$game_id = $row['rating_game'];
			$rtotal += $row['rating_score'];
		}
		$db->sql_freeresult($result);
		$rtotal = number_format($rtotal / $row_count, 0);
		$sql_ary = array(
			'game_rating'		=> $rtotal,
			'game_num_ratings'	=> $row_count
		);
		$sql = 'UPDATE ' . AR_GAMES_TABLE . '
			SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
			WHERE game_id = ' . (int) $game_id;
		$db->sql_query($sql);
	break;
	case 'setgame':
		// Deny $HTTP_GET_VARS Mode Games
		if($HTTP_GET_VARS['g'])
		{
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&action=p', false, $user->session_id);
			header("Location: $url_loc");	
		}
		if ($game_newscore == true && $user->data['is_registered'])
		{
			// Check if user is already set playing a game
			$sql = 'SELECT COUNT(viewing_user) AS row_count FROM ' . AR_VIEWING_TABLE . ' WHERE viewing_user = ' . $user->data['user_id'];
			$result = $db->sql_query($sql);
			$row_count = (int) $db->sql_fetchfield('row_count');
			$db->sql_freeresult($result);
			if ($row_count)
			{
				// Check if user is already set playing a game
				$sql = 'SELECT COUNT(viewing_user) AS row_count FROM ' . AR_VIEWING_TABLE . ' WHERE viewing_user = ' . $user->data['user_id'] . ' AND viewing_game = ' . $game_id;
				$result = $db->sql_query($sql);
				$row_count = (int) $db->sql_fetchfield('row_count');
				$db->sql_freeresult($result);
				if (!$row_count)
				{
					$sql_ary = array(
						'viewing_game'		=> $game_id
					);
					$sql = 'UPDATE ' . AR_VIEWING_TABLE . '
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE viewing_user = ' . (int) $user->data['user_id'];
					$db->sql_query($sql);
				}
			}
			else
			{
				$sql_ary = array(
					'viewing_user'		=> $user->data['user_id'],
					'viewing_game'		=> $game_id
				);
				$sql = 'INSERT INTO ' . AR_VIEWING_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
			}
		}
		else
		{
			$sql = 'DELETE FROM ' . AR_VIEWING_TABLE . ' WHERE viewing_user = ' . (int) $user->data['user_id'];
			$db->sql_query($sql);
		}
		die('done');
	break;
}

if ($action != 'edit')
{
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $user->lang['ARCADE'],
	'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}arcade.$phpEx", '', true, $user->session_id))
);

// Check if game_id is a valid game
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . " WHERE game_id = $game_id";
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if (!$row_count)
{
	header("Location: arcade.php");
}
else
{
	$valid_game = true;
}
$db->sql_freeresult($result);

// Check if guests can increase the number of plays a game has been played
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 2 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count && $action === '' && $user->data['is_registered'])
{
	// Update number of game plays this game has been played
	$sql = 'UPDATE ' . AR_GAMES_TABLE . ' SET game_plays = game_plays + 1 WHERE game_id = ' . (int) $game_id;
	$db->sql_query($sql);
}
if ($user->data['is_registered'] && $action === '')
{
	// Update number of game plays this game has been played
	$sql = 'UPDATE ' . AR_GAMES_TABLE . ' SET game_plays = game_plays + 1 WHERE game_id = ' . (int) $game_id;
	$db->sql_query($sql);
}
$db->sql_freeresult($result);
//Check how many users favorited the game
$sql = 'SELECT COUNT(favorite_id) AS row_count FROM ' . AR_FAVORITES_TABLE . ' WHERE favorite_game = ' . (int) $game_id;
$result = $db->sql_query($sql);
$fav_count = (int) $db->sql_fetchfield('row_count');
$db->sql_freeresult($result);

if ($valid_game)
{
	// Make sure the game currently being played is on the users played game list
	$sql = 'SELECT played_id, played_games
		FROM ' . AR_PLAYED_TABLE . '
		WHERE played_user = ' . (int) $user->data['user_id'];
	$result = $db->sql_query($sql);
	$played_games = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$played_games = explode('-', $row['played_games']);
		$played_id = $row['played_id'];
	}
	$db->sql_freeresult($result);
	foreach($played_games as $value)
	{
		if ($value == $game_id)
		{
			$already_listed = true;
		}
	}
	if ($already_listed != true)
	{
		array_push($played_games, $game_id);
		$games_played = implode('-', $played_games);
		if (!$played_id)
		{
			$sql_ary = array(
				'played_user'		=> $user->data['user_id'],
				'played_games'		=> $games_played
				
			);
			$sql = 'INSERT INTO ' . AR_PLAYED_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
		else
		{
			$sql_ary = array(
				'played_user'		=> $user->data['user_id'],
				'played_games'		=> $games_played
			);
			
			$sql = 'UPDATE ' . AR_PLAYED_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
				WHERE played_id = ' . (int) $played_id;
			$db->sql_query($sql);
		}
	}
}

// Grab group details for game display
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_id = ' . $game_id . '
	ORDER BY game_name';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	if ($user->data['is_registered'])
	{
		$rate1 = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=rategame&rating=1&g=' . $row['game_id'], true, $user->session_id);
		$rate2 = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=rategame&rating=2&g=' . $row['game_id'], true, $user->session_id);
		$rate3 = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=rategame&rating=3&g=' . $row['game_id'], true, $user->session_id);
		$rate4 = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=rategame&rating=4&g=' . $row['game_id'], true, $user->session_id);
		$rate5 = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=rategame&rating=5&g=' . $row['game_id'], true, $user->session_id);
		$starbegin = "<a href='";
		$staryes =  "'><img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' /></a>";
		$star = "'><img src='$phpbb_root_path/arcade/images/star.gif' alt='*' /></a>";
		if ($row['game_rating'] == 0)
		{
			$rstars = $starbegin . $rate1 . $star . $starbegin . $rate2 . $star . $starbegin . $rate3 . $star . $starbegin . $rate4 . $star . $starbegin . $rate5 . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $starbegin . $rate1 . $staryes . $starbegin . $rate2 . $star . $starbegin . $rate3 . $star . $starbegin . $rate4 . $star . $starbegin . $rate5 . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $starbegin . $rate1 . $staryes . $starbegin . $rate2 . $staryes . $starbegin . $rate3 . $star . $starbegin . $rate4 . $star . $starbegin . $rate5 . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $starbegin . $rate1 . $staryes . $starbegin . $rate2 . $staryes . $starbegin . $rate3 . $staryes . $starbegin . $rate4 . $star . $starbegin . $rate5 . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $starbegin . $rate1 . $staryes . $starbegin . $rate2 . $staryes . $starbegin . $rate3 . $staryes . $starbegin . $rate4 . $staryes . $starbegin . $rate5 . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $starbegin . $rate1 . $staryes . $starbegin . $rate2 . $staryes . $starbegin . $rate3 . $staryes . $starbegin . $rate4 . $staryes . $starbegin . $rate5 . $staryes;
		}
		//check if current user favorited the game
		$sql = 'SELECT favorite_id FROM ' . AR_FAVORITES_TABLE . '
			WHERE favorite_user = ' . $user->data['user_id'] . '
				AND favorite_game = ' . $row['game_id'];
		$result2 = $db->sql_query($sql);
		$favorite_id = (int) $db->sql_fetchfield('favorite_id');
		$db->sql_freeresult($result2);
		if ($favorite_id)
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_r.gif' alt='*' />";
			$u_add_remove = 'viewgame.php?action=remove&g=' . $row['game_id'];
		}
		else
		{
			$game_add_remove = "<img src='$phpbb_root_path/arcade/images/star_p.gif' alt='*' />";
			$u_add_remove = 'viewgame.php?action=add&g=' . $row['game_id'];
		}
	} else {
		$staryes =  "<img src='$phpbb_root_path/arcade/images/star_yes.gif' alt='*' />";
		$star = "<img src='$phpbb_root_path/arcade/images/star.gif' alt='*' />";
		if ($row['game_rating'] == 0)
		{
			$rstars = $star . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 1)
		{
			$rstars = $staryes . $star . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 2)
		{
			$rstars = $staryes . $staryes . $star . $star . $star;
		}
		elseif ($row['game_rating'] == 3)
		{
			$rstars = $staryes . $staryes . $staryes . $star . $star;
		}
		elseif ($row['game_rating'] == 4)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $star;
		}
		elseif ($row['game_rating'] == 5)
		{
			$rstars = $staryes . $staryes . $staryes . $staryes . $staryes;
		}
	}
	$description = censor_text($row['game_description']);
	$description = str_replace("\n", '<br />', $description);
	$directions = censor_text($row['game_directions']);
	$directions = str_replace("\n", '<br />', $directions);
	// Send vars to template
	$filename = 'arcade/' . $row['game_filename'];
	if($hotlink_protection)
	{
		$sql2 = 'SELECT *
			FROM ' . AR_HOTLINKS_TABLE . '
			WHERE hotlink_game = ' . $game_id;
		$result2 = $db->sql_query($sql2);
		$row2 = $db->sql_fetchrow($result2);
		$db->sql_freeresult($result2);
		$make_new = false;
		if(isset($row2['hotlink_file']))
		{
			$time = time();
			$file_life = $time - filemtime($row2['hotlink_file']);
			if ($file_life > 60)
			{
				unlink($row2['hotlink_file']);
				$sql3 = 'DELETE FROM ' . AR_HOTLINKS_TABLE . ' WHERE hotlink_id = ' . (int) $row2['hotlink_id'];
				$db->sql_query($sql3);
				$make_new = true;
			}
			else
			{
				$filename = $row2['hotlink_file'];
			}
		}
		else
		{
			$make_new = true;
		}
		if($make_new == true)
		{
			$new_name = 'arcade/tmp/' . file_temp_name('.swf');
			copy($filename, $new_name);
			$sql_ary = array(
				'hotlink_game'		=> $game_id,
				'hotlink_file'		=> $new_name
			);
			$sql4 = 'INSERT INTO ' . AR_HOTLINKS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql4);
			$filename = $new_name;
		}
	}
	$template->assign_block_vars('gamerow', array(
			'GAME_ID'			=> $row['game_id'],
			'GAME_NAME'			=> $row['game_name'],
			'GAME_IMAGE'		=> $row['game_image'],
			'GAME_DESC'			=> $description,
			'GAME_DIR'			=> $directions,
			'GAME_FILENAME'		=> $filename,
			'GAME_WIDTH'		=> $row['game_width'],
			'GAME_HEIGHT'		=> $row['game_height'],
			'GAME_PLAY'			=> $row['game_plays'],
			'GAME_RATING'		=> $rstars,
			'GAME_NUMRATINGS'	=> $row['game_num_ratings'],
			'GAME_NUMFAVORITES'	=> $fav_count,
			'GAME_SIZE'			=> get_file_size($filename),
			'GAME_ADD_REMOVE'	=> $game_add_remove,
			'U_ADD_REMOVE'		=> $u_add_remove
	));
}
$db->sql_freeresult($result);

$sql = 'SELECT *
    FROM ' . AR_COMMENTS_TABLE . '
	WHERE comment_game = ' . $game_id . '
	ORDER BY comment_id DESC
	LIMIT ' . $offset . ',5';
$result = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($result))
{
	// Grab game details for a total count for the category
	$sql = 'SELECT username, user_colour
		FROM ' . USERS_TABLE . '
		WHERE user_id = ' . (int) $row['comment_user'];
	$result2 = $db->sql_query($sql);
	$row2 = $db->sql_fetchrow($result2);
	$username = get_username_string('full', $row['comment_user'], $row2['username'], $row2['user_colour'], $row2['username']);
	$db->sql_freeresult($result2);
	$delete = '';
	if ($auth->acl_getf_global('m_') || $user->data['user_id'] == $row['comment_user'])
	{
		$delete = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=delete&c=' . $row['comment_id'] . '&g=' . $game_id, true, $user->session_id);
	}
	if ($auth->acl_getf_global('m_') || $user->data['user_id'] == $row['comment_user'])
	{
		$edit = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'action=edit&c=' . $row['comment_id'] . '&g=' . $game_id, true, $user->session_id);
	}
	$row['bbcode_options'] = (($row['enable_bbcode']) ? OPTION_FLAG_BBCODE : 0) +
    (($row['enable_smilies']) ? OPTION_FLAG_SMILIES : 0) + 
    (($row['enable_magic_url']) ? OPTION_FLAG_LINKS : 0);
	$message = generate_text_for_display($row['comment'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);
	
	// Holding maximum post time for marking topic read
	// We need to grab it because we do reverse ordering sometimes
	$sql2 = 'SELECT *
		FROM ' . USERS_TABLE . '
		WHERE user_id = ' . $row['comment_user'];
	$result2 = $db->sql_query($sql2);
	
	// Posts are stored in the $rowset array while $attach_list, $user_cache
	// and the global bbcode_bitfield are built
	while ($row2 = $db->sql_fetchrow($result2))
	{
		// Cache various user specific data ... so we don't have to recompute
		// this each time the same user appears on this page
		if (!isset($user_cache[$row['comment_user']]))
		{
			$id_cache[] = $row['comment_user'];
			$user_cache[$row['comment_user']] = array(
				'viewonline'	=> $row2['user_allow_viewonline'],
	
				'online'		=> false,
	
				'avatar'		=> ($user->optionget('viewavatars')) ? get_user_avatar($row2['user_avatar'], $row2['user_avatar_type'], $row2['user_avatar_width'], $row2['user_avatar_height']) : '',
	
				'rank_title'		=> '',
				'rank_image'		=> '',
				'rank_image_src'	=> '',
			);
	
			get_user_rank($row2['user_rank'], $row2['user_posts'], $user_cache[$row['comment_user']]['rank_title'], $user_cache[$row['comment_user']]['rank_image'], $user_cache[$row['comment_user']]['rank_image_src']);
		}
	}
	$db->sql_freeresult($result2);
	unset($today);
	// Generate online information for user
	if ($config['load_onlinetrack'] && sizeof($id_cache))
	{
		$sql3 = 'SELECT session_user_id, MAX(session_time) as online_time, MIN(session_viewonline) AS viewonline
			FROM ' . SESSIONS_TABLE . '
			WHERE ' . $db->sql_in_set('session_user_id', $id_cache) . '
			GROUP BY session_user_id';
		$result3 = $db->sql_query($sql3);
	
		$update_time = $config['load_online_time'] * 60;
		while ($row3 = $db->sql_fetchrow($result3))
		{
			$user_cache[$row3['session_user_id']]['online'] = (time() - $update_time < $row3['online_time'] && (($row3['viewonline'] && $user_cache[$row3['session_user_id']]['viewonline']) || $auth->acl_get('u_viewonline'))) ? true : false;
		}
		$db->sql_freeresult($result3);
	}
	unset($id_cache);	
	
	// Send vars to template
	$template->assign_block_vars('commentrow', array(
			'COMMENT_USER'		=> $username,
			'COMMENT'			=> $message,
			'U_DELETE'			=> $delete,
			'U_EDIT'			=> $edit,
			'S_ONLINE'			=> ($row['comment_user'] == ANONYMOUS || !$config['load_onlinetrack']) ? false : (($user_cache[$row['comment_user']]['online']) ? true : false),
			'POSTER_AVATAR'		=> $user_cache[$row['comment_user']]['avatar'],
			'RANK_TITLE'		=> $user_cache[$row['comment_user']]['rank_title'],
			'RANK_IMG'			=> $user_cache[$row['comment_user']]['rank_image'],
			'RANK_IMG_SRC'		=> $user_cache[$row['comment_user']]['rank_image_src'],
	));
	$template->assign_vars(array(
			'S_HAS_COMMENTS'		=> true
	));
}
$db->sql_freeresult($result);

// Check if game can be has reverse scoring
$sql = 'SELECT COUNT(game_id) AS row_count FROM ' . AR_GAMES_TABLE . ' WHERE game_id = ' . $game_id . ' AND game_rev_score = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$rev_scoring = 'ASC';
}
else
{
	$rev_scoring = 'DESC';
}

$sql = 'SELECT highscore_user, highscore
    FROM ' . AR_HIGHSCORES_TABLE . '
	WHERE highscore_game = ' . $game_id . '
	ORDER BY highscore ' . $rev_scoring;
$result = $db->sql_query($sql);
while ($row = $db->sql_fetchrow($result))
{
	// Grab game details for a total count for the category
	$sql = 'SELECT username, user_colour
		FROM ' . USERS_TABLE . '
		WHERE user_id = ' . (int) $row['highscore_user'];
	$result2 = $db->sql_query($sql);
	$row2 = $db->sql_fetchrow($result2);
	$username = get_username_string('full', $row['highscore_user'], $row2['username'], $row2['user_colour'], $row2['username']);
	$db->sql_freeresult($result2);
	
	$user_ids[$username] = $row['highscore_user'];
	@$highscores[$username][sizeof($highscores[$username])] = str_replace('.0', '', $row['highscore']);
}
if (@$highscores)
{
	$bronze = "<img src='{$phpbb_root_path}/arcade/images/trophy_bronze.gif' align='absmiddle' alt='bronze' />";
	$silver = "<img src='{$phpbb_root_path}/arcade/images/trophy_silver.gif' align='absmiddle' alt='silver' />";
	$gold = "<img src='{$phpbb_root_path}/arcade/images/trophy_gold.gif' align='absmiddle' alt='gold' />";
	$user_count = 0;
	$prev_highscore = 0;
	$gold_pos = 1;
	$silver_pos = 2;
	$bronze_pos = 3;
	foreach($highscores as $key => $value)
	{
		unset($extra);
		if ($user_ids[$key] == $user->data['user_id'])
		{
			$current_user = true;
		}
		else
		{
			$current_user = false;
		}
		$score_count = sizeof($highscores[$key]);
		if ($highscores[$key][0] == $prev_highscore)
		{
			if ($user_count <= $gold_pos)
				{
					$gold_pos++;
					$silver_pos++;
					$bronze_pos++;
				}
				else if ($user_count <= $silver_pos)
				{
					$silver_pos++;
					$bronze_pos++;
				}
				else if ($user_count <= $bronze_pos)
				{
					$bronze_pos++;
				}
		}
		$prev_highscore = $highscores[$key][0];
		if ($score_count > 1)
		{
			$url_loc = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $game_id . '&amp;u=' . $user_ids[$key] . '&amp;action=viewhighscore', true, $user->session_id);
			$extra = "(<a href='$url_loc'>$score_count</a>)";
		}
		$user_count++;
		if ($user_count < 10)
		{
			if (sizeof($user_ids) > 2)
			{
				if ($user_count <= $gold_pos)
				{
					@$extra .= $gold;
				}
				else if ($user_count <= $silver_pos)
				{
					@$extra .= $silver;
				}
				else if ($user_count <= $bronze_pos)
				{
					@$extra .= $bronze;
				}
			}
			else
			{
				$template->assign_vars(array(
					'S_NOT_ENOUGH'		=> true
				));
			}
			// Send vars to template
			$template->assign_block_vars('scorerow', array(
					'SCORE_USER'	=> $key . @$extra,
					'SCORE'			=> $highscores[$key][0],
					'CURRENT_USER'	=> $current_user
			));
		}
		elseif ($user_count < 30)
		{
			// Send vars to template
			$template->assign_block_vars('extrascorerow', array(
					'SCORE_USER'	=> $key . @$extra,
					'SCORE'			=> $highscores[$key][0],
					'CURRENT_USER'	=> $current_user
			));
			$template->assign_vars(array(
					'S_EXTRA_SCORES'		=> true
			));
		}
	}
}
$db->sql_freeresult($result);

// Check if guests can view the arcade
$sql = 'SELECT COUNT(setting_id) AS row_count FROM ' . AR_SETTINGS_TABLE . ' WHERE setting_id = 1 AND setting_value = 1';
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count)
{
	$template->assign_vars(array(
			'S_VIEW'		=> true
	));
}
$db->sql_freeresult($result);
if ($user->data['is_registered'])
{
	$template->assign_vars(array(
			'S_VIEW'		=> true,
			'S_BBCODE_ALLOWED'	=> true
	));
}

// Grab game details for a total comment count
$sql = 'SELECT COUNT(comment_id) AS row_count FROM ' . AR_COMMENTS_TABLE . ' WHERE comment_game = ' . $game_id;
$result = $db->sql_query($sql);
$row_count = (int) $db->sql_fetchfield('row_count');
if ($row_count != 1)
{
	$template->assign_vars(array(
		'L_NUM_COMMENTS'	=> $row_count . ' ' . $user->lang['COMMENTS']
	));
}
else
{
	$template->assign_vars(array(
		'L_NUM_COMMENTS'	=> $row_count . $user->lang['COMMENT']
	));
}

if ($user->data['is_registered'] && $allow_comments)
{
	$url = $phpbb_root_path . 'viewgame.' . $phpEx . "?action=comment&amp;g=$game_id";
	$template->assign_vars(array(
			'S_COMMENT'		=> true,
			'U_ACTION'		=> $url
	));
}
if ($user->data['is_registered'] && $allow_favorites)
{
	$template->assign_vars(array(
			'S_ALLOW_FAV'	=> true
	));
}
if ($game_highscore)
{
	$template->assign_vars(array(
			'S_HIGHSCORE'	=> true
	));
}
if ($game_newscore == true && $user->data['is_registered'])
{
	$template->assign_vars(array(
			'S_NEWSCORE'	=> true
	));
}

$template->assign_vars(array(
		'S_ARCADE'	=> true,
));

// Grab arcade details for nav display
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_id = ' . $game_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
$sql = 'SELECT *
	FROM ' . AR_CATEGORIES_TABLE . '
	WHERE category_id = ' . $row['game_category'];
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $row['category_name'],
	'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}viewcategory.$phpEx", 'c=' . $row['category_id'], true, $user->session_id))
);

// Grab game details for previous and next games
$list_count = 0;
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_id = ' . $game_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
$sql = 'SELECT *
	FROM ' . AR_GAMES_TABLE . '
	WHERE game_category = ' . $row['game_category'] . '
	ORDER BY game_name';
$result = $db->sql_query($sql);
while ($row = $db->sql_fetchrow($result))
{
	$arcade_list[$list_count] = $row['game_id'];
	$list_count++;
}
foreach($arcade_list as $key => $value)
{
	if ($value == $game_id)
	{
		$cur_game_loc = $key;
	}
}
$previous_url = '';
$next_url = '';
if ($cur_game_loc != 0)
{
	$previous_url = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $arcade_list[$cur_game_loc-1], false, $user->session_id);
}
if ($cur_game_loc != sizeof($arcade_list)-1)
{
	$next_url = append_sid("{$phpbb_root_path}viewgame.$phpEx", 'g=' . $arcade_list[$cur_game_loc+1], false, $user->session_id);
}
$template->assign_vars(array(
		'PREVIOUS_PAGE'		=> $previous_url,
		'NEXT_PAGE'			=> $next_url
));
}

page_footer();

?>